/**
 *一个基础的工具js
 * @author zhg 
 */
 /***
 *简单的像jQuery的选择器
 */
function $(idstr)
{
    var ele = document.querySelectorAll(idstr);
    if (ele.length == 0)
    {
        return null;
    } else if (ele.length == 1)
    {
        return ele[0];
    } else
    {
        return ele;
    }
}
/**
*返回document.getElementById
*/
function id(idstr)
{
    return document.getElementById(idstr);
}
/**
*简单的提示,用window.alert
*/
function tip(msg)
{
    layer.msg(msg);
}

/**
*拼接数据,Object的key-value
*/
function makeDataStr(obj)
{
    var eles = Object.keys(obj);
    var data = "";
    for (var i = 0; i < eles.length; i++)
    {
        var ele = eles[i];
		var value=obj[ele];
		if(Array.isArray(value))
		{
			for(var i=0;i<value.length;i++)
			{
				data = data + encodeURIComponent(ele) + "=" + encodeURIComponent(value[i]) + "&";
			}
		}else if(value!=null)
		{
			data = data + encodeURIComponent(ele) + "=" + encodeURIComponent(value) + "&";
		} 
    } 
    return data;
}
/**
*拼接数据,FormData的key-value
*/
function makeFormDataStr(frt)
{ 
    var data = "";
    for (var key of frt.keys()) 
	{
		var value=frt.get(key);
		if(Array.isArray(value))
		{
			for(var i=0;i<value.length;i++)
			{
				data = data + encodeURIComponent(key) + "=" + encodeURIComponent(value[i]) + "&";
			}
		}else if(value!=null)
		{
			data = data + encodeURIComponent(key) + "=" + encodeURIComponent(value) + "&";
		}  
	}
	
    return data;
}
/**
 *  post方式提交内容,返回json,使用方法:
 *  post(url)
 *  post(url,data)
 *  post(url,data,success)
 *  post(url,data,success,err)
 *  post(url,success)
 *  post(url,success,err)
 */
function post()
{
    var url;
    var data;
    var success;
    var error;
    url = arguments[0];
    var urlencoded=false;
    if (typeof (arguments[1]) == "string")
    {
        data = arguments[1];
        success = arguments[2];
        error = arguments[3];
        urlencoded=true;
    }else if (arguments[1] instanceof FormData)
    {
        data = makeFormDataStr(arguments[1]);
        success = arguments[2];
        error = arguments[3];
    }else if (typeof (arguments[1]) == "object")
    {
        data =makeDataStr(arguments[1]);
        success = arguments[2];
        error = arguments[3];
		urlencoded=true;
    } else if (typeof (arguments[1]) == "function")
    {
        success = arguments[1];
        error = arguments[2];
    }
    var req = new XMLHttpRequest();
    req.open("post", url);
    if(urlencoded)
    {
      req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    }
    req.responseType = "json";
	req.withCredentials=true;
    req.onload = function ()
    {
        if (req.status === 200)
        {
            if (success)
            { 
                if (typeof (req.response) === "string")
                {
                    success(JSON.parse(req.response));
                } else
                {
                    success(req.response);
                }
            }
        } else
        {
            if (error)
            {
                error(req.statusText);
            }
        }

    };
    req.onerror = function (err)
    {
        if (error)
        {
            error(err);
        }
    };
	if(data==null)
	{
		 req.send();
	}else
	{
		 req.send(data);
	}
   
}
/**
 *  get方式提交内容,使用方法:
 *  get(url)
 *  get(url,data)
 *  get(url,data,success)
 *  get(url,data,success,err)
 *  get(url,success)
 *  get(url,success,err)
 */
function get()
{
    var url;
    var data;
    var success;
    var error;
    url = arguments[0];
    var urlencoded=false;
    if (typeof (arguments[1]) == "string")
    {
        data = arguments[1];
		if(data[0]=="?")//除去前置'?'
		{
			data=data.substr(1);
		}
        success = arguments[2];
        error = arguments[3];
        urlencoded=true;
    }else if (arguments[1] instanceof FormData)
    {
        data = arguments[1];
        success = arguments[2];
        error = arguments[3];
    }else if (typeof (arguments[1]) == "object")
    {
        data =makeDataStr(arguments[1]);
        success = arguments[2];
        error = arguments[3];
		urlencoded=true;
    } else if (typeof (arguments[1]) == "function")
    {
        success = arguments[1];
        error = arguments[2];
    }
	//合并data到url中
	if(data!=null)
	{ 
		if(url.indexOf("?")!=-1)
		{
			url=url+"&"+data;
		}else
		{
			url=url+"?"+data;
		}		
	}
    var req = new XMLHttpRequest();
    req.open("get", url);
    if(urlencoded)
    {
      req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    }
    req.responseType = "json";
	req.withCredentials=true;
    req.onload = function ()
    {
        if (req.status === 200)
        {
            if (success)
            { 
                if (typeof (req.response) === "string")
                {
                    success(JSON.parse(req.response));
                } else
                {
                    success(req.response);
                }
            }
        } else
        {
            if (error)
            {
                error(req.statusText);
            }
        }

    };
    req.onerror = function (err)
    {
        if (error)
        {
            error(err);
        }
    };
    req.send(); 
} 
/**
*保持两位数
*/
function Z0(i)
{
	return i<10?"0"+i:i;
}
/***
*格式化日期时间 yyyy-MM-dd HH:mm:ss
*/
function formatDateTime(da)
{
	return da.getFullYear()+"-"+Z0(da.getMonth()+1)+"-"+Z0(da.getDate())+" "+Z0(da.getHours())+":"+Z0(da.getMinutes())+":"+Z0(da.getSeconds());
}
/***
*格式化时间 HH:mm:ss
*/
function formatTime(da)
{
	return Z0(da.getHours())+":"+Z0(da.getMinutes())+":"+Z0(da.getSeconds());
}
/***
*格式化月份时间 MM-dd HH:mm:ss
*/
function formatMonthTime(da)
{
	return Z0(da.getMonth()+1)+"-"+Z0(da.getDate())+" "+Z0(da.getHours())+":"+Z0(da.getMinutes())+":"+Z0(da.getSeconds());
}
/***
*比较同一年份内
*/
function isSameYear(now,da)
{ 
	return da.getFullYear()==now.getFullYear();
}
/***
*比较同一天内
*/
function isSameDay(now,da)
{ 
	return da.getFullYear()==now.getFullYear()&&da.getMonth()==now.getMonth()&&da.getDate()==now.getDate();
} 

/**
*格式化最后时间,n秒前 -> n分钟前 -> HH:mm:ss -> MM-dd HH:mm:ss -> yyyy-MM-dd HH:mm:ss
*/
function formatLastTime(da)
{ 
	var now=new Date();
	var diff=now.getTime()-da.getTime();
	if(diff<0)//时间n秒后?
	{
		return formatDateTime(da);
	}else if(diff < 60 * 1000)
	{
		return parseInt(diff / 1000) + "秒前";
	} else if (diff < 60 * 60 * 1000)// 1小时前
	{
		return parseInt(diff / 60 / 1000) + "分种前";
	} else if (isSameDay(now, da))
	{
		return formatTime(da );
	} else if (isSameYear(now, da))
	{
		return formatMonthTime(da );
	} else
	{
		return formatDateTime(da );
	}
}
/**
*Blob转换成Base64编码
* @param obj Blob 
*/
function toBase64(obj,callback)
{
	if(obj==null){
		return;
	};
	if(obj instanceof Blob)
	{
		var reader  = new FileReader();
		reader.addEventListener("load", function () {
			if(callback)
			{
				callback(reader.result);
			} 
		}, false);
		reader.readAsDataURL(obj);
	}
}
/**
*
*解析location.search为key-value
*/
function searchMap()
{
	var map={};
	if(location.search.length>1)
	 {
		var parts=location.search.substr(1).split("&");
		for(var i=0;i<parts.length;i++)
		{
			var kvs=parts[i].split("="); 
			map[kvs[0]]=decodeURIComponent(kvs[1]); 
		}
	 }
	 return map;
}
